// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#include "fem/BC_evaluator.h"

//-----------------------------------------------------------------------------
template<>
void BC_evaluator<Boundary_condition, Mesh_face>::eval(Boundary_value& value, Mesh_node const& n, size_t i) const
{
    m_bc->eval(value, n.point(), i);
}
//-----------------------------------------------------------------------------
template<>
void BC_evaluator<Direct_boundary_condition, Mesh_face>::eval(Boundary_value& value, Mesh_node const& n, size_t i) const
{
    m_bc->eval(value, n, i);
}
//-----------------------------------------------------------------------------
template<>
void BC_evaluator<Direct_boundary_condition, Mesh_face>::set_bc( Direct_boundary_condition *bc, Node_handle nh )
{
    m_bc = bc;
    Boundary_value bv;
    int i = 0;
//just check  if any of dofs of the node is restricted
    while (i < 3 && (!bv.is_set()))
    {
        bc->eval(bv, *nh, i);

        if (bv.is_set())
        {
            m_boundary.push_back(BC_evaluator_element<Mesh_face>(nh));
        }
        ++i;
    }
}
//-----------------------------------------------------------------------------
template<>
void BC_evaluator<Boundary_condition, Mesh_face>::set_bc( Boundary_condition *bc, Node_handle nh )
{
    m_bc = bc;
    Boundary_value bv;
    int i = 0;
//just check  if any of dofs of the node is restricted
    while (i < 3 && (!bv.is_set()))
    {
        bc->eval(bv, nh->point(), i);

        if (bv.is_set())
        {
            m_boundary.push_back(BC_evaluator_element<Mesh_face>(nh));
        }
        ++i;
    }
}
//-----------------------------------------------------------------------------
