// Copyright (C) 2011 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _BC_EVALUATOR_LIST_H_
#define _BC_EVALUATOR_LIST_H_

#include "fem/BC_evaluator.h"
#include <list>
//-----------------------------------------------------------------------------
template<class BC, class ME>
class BC_evaluator_list : public std::list<BC_evaluator<BC, ME> *>
{
    typedef std::list<BC_evaluator<BC, ME> *> base_list;
public:
    typedef BC_evaluator<BC, ME> Evaluator;
    typedef BC BCondition;

    //Empty boundary condition list
    BC_evaluator_list() {}
    //Boundary condition list with single evaluator
    BC_evaluator_list(BC_evaluator<BC, ME> *bcev)
    {
        this->push_back(bcev);
    }

    void add(BC_evaluator<BC, ME> *bcev)
    {
        this->push_back(bcev);
    }
    void remove(BC_evaluator<BC, ME> *bcev)
    {
        remove(bcev);
    }
};
//-----------------------------------------------------------------------------
#endif
