// Copyright (C) 2005 Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Modified by Garth N. Wells 2005.
// Modified by Pawel Krupinski 2007

#ifndef __BOUNDARY_CONDITION_H
#define __BOUNDARY_CONDITION_H

#include "utils/types.h"
//#include <constants.h>

class Boundary_value;

/// This class specifies the interface for boundary conditions for
/// partial differential equations. To specify a boundary condition,
/// a user must create a subclass of Boundary_condition and overload
/// the eval() function, specifying a boundary value as function of
/// the coordinates of degrees of freedom on the boundary.

class Boundary_condition
{
public:

//	typedef Positional_boundary_condition Category;
    /// Constructor
    Boundary_condition();

    /// Destructor
    virtual ~Boundary_condition();

    /// Evaluate boundary condition at given point p and component i
    virtual void eval ( Boundary_value& value, const Point& p, size_t i ) const = 0;

};


#endif
