// Copyright (C) 2005 Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Modified by Garth N. Wells, 2006
// Modified by Pawel Krupinski 2007

#ifndef __BOUNDARY_VALUE_H
#define __BOUNDARY_VALUE_H

//#include "constants.h"

class Boundary_value
{
public:

    /// Create default boundary value (homogeneous Neumann)
    Boundary_value();

    /// Destructor
    ~Boundary_value();

    /// Set Dirichlet boundary value
    const Boundary_value& operator= ( double value );

    /// Set Dirichlet boundary value
    void set ( double value );

    /// Reset Dirichlet boundary value
    void reset();

    /// Check if value was set
    bool is_set() const
    {
        return fixed;
    }

    /// Friends
    friend class FEM;

private:

    // True if boundary value is fixed (Dirichlet)
    bool fixed;

    // The boundary value
    double value;

};


#endif
