// Copyright (C) 2010 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.

#ifndef _DOF_MAP_H_
#define _DOF_MAP_H_

class DOF_map
{
public:
    /// Get positions of dofs at given Mesh_node in global matrix/vector
    void vertexmap(size_t *dof_index, Mesh_node const *vertex, const Mesh& mesh) const
    {
        int n_nodes = mesh.size_of_nodes();
        for (int i = 0; i < 6; ++i)
            dof_index[i] = vertex->id()+i*n_nodes;
    }
    /// Compute map from local to global degrees of freedom for quad
    void nodemap(size_t *dofs, const Mesh_face& cell, const Mesh& mesh) const
    {
        int n_nodes = mesh.size_of_nodes();
        Mesh_face const& c = cell;
        Mesh_face::Edge_use_const_circulator n_circ, n_start;
        n_circ = c.edge_uses_begin();
        n_start = n_circ;
        int n = 0;

        do {

            for (int i = 0; i < 6; ++i)
            {

                dofs[i*4+n] = n_circ->node()->id()+i*n_nodes;
            }
            ++n;
        } while (++n_circ != n_start);
    }
};
//-----------------------------------------------------------------------------
#endif
