#include "fem/FEM.h"
//-----------------------------------------------------------------------------
size_t FEM::size(const Mesh& mesh, const Finite_element& element)
{
    return mesh.size_of_nodes() * element.tensordim();
}
//-----------------------------------------------------------------------------
void FEM::lump(const SparseMatrix& M, DenseVector& m)
{
    m.init(M.size(0));

    DenseVector one(m);
    one = 1.0;

    M.mult(one, m);
}
//-----------------------------------------------------------------------------
size_t FEM::nzsize(const Mesh& mesh, const Finite_element& element)
{
    int nzmax = 0;
    for (Mesh::Node_const_iterator n_iter = mesh.nodes_begin() ; n_iter != mesh.nodes_end(); ++n_iter)
        nzmax = std::max( nzmax, n_iter->degree() );

    return nzmax * element.spacedim();
}
//-----------------------------------------------------------------------------
