// Copyright (C) 2005-2006 Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Modified by Pawel Krupinski 2007

#include <string>
#include "fem/elements/Quad_shell.h"
#include "fem/elements/invalid_element.h"
#include "fem/Finite_element.h"
Quad_shell* Quad_shell::m_instance = NULL;
Invalid_element * Invalid_element::m_instance = NULL;
//-----------------------------------------------------------------------------
Finite_element::Finite_element()
{
}
//-----------------------------------------------------------------------------
Finite_element::~Finite_element()
{
}
//-----------------------------------------------------------------------------
Finite_element* Finite_element::makeElement(const Finite_element_spec& spec)
{
    // Find the correct element from the string representation
    std::string repr = spec.repr();
    
    if ( repr == "[ Invalid finite element of degree 0 on a invalid ]" )
        return Quad_shell::instance();
    else if ( repr == "[ Shell finite element of degree 1 on a quadrilateral ]" )
        return Quad_shell::instance();
    cell_error(repr.c_str());
    cell_error("Unable to create specified finite element, no matching precompiled element found.");
    return 0;
}
//-----------------------------------------------------------------------------
Finite_element* Finite_element::makeElement(std::string type, std::string shape, size_t degree, size_t vectordim)
{
    Finite_element_spec spec(type, shape, degree, vectordim);
    return makeElement(spec);
}
//-----------------------------------------------------------------------------
void Finite_element::disp() const
{
    cell_info("Finite element data:");
    cell_info("  space dimension = %d", spacedim());
    cell_info("  shape dimension = %d", shapedim());
}
//-----------------------------------------------------------------------------
