// Copyright (C) 2005-2006 Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Modified by Pawel Krupinski 2007

#ifndef __FINITE_ELEMENT_H
#define __FINITE_ELEMENT_H

#include "mesh/mesh.h"

#include "fem/shape_function.h"
#include "fem/Finite_element_spec.h"
#include "fem/DOF_map.h"

//The base class for finite elements
class Finite_element : public Shape_function, public DOF_map
{
public:
    Finite_element();

    virtual ~Finite_element();
    virtual size_t spacedim() const = 0;
    virtual size_t shapedim() const = 0;
    virtual size_t tensordim() const = 0;
    virtual Finite_element_spec spec() const = 0;

    static Finite_element* makeElement(const Finite_element_spec& spec);
    static Finite_element* makeElement(std::string type, std::string shape, size_t degree, size_t vectordim );
    void disp() const;
};
//-----------------------------------------------------------------------------

#endif
