// Copyright (C) 2006 Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Modified by Pawel Krupinski 2007

#ifndef __FINITE_ELEMENT_SPEC_H
#define __FINITE_ELEMENT_SPEC_H

#include <string>

class Finite_element_spec
{
public:

    Finite_element_spec();
    Finite_element_spec(std::string type);

    Finite_element_spec(std::string type, std::string shape, size_t degree, size_t vectordim = 0);
    void init(std::string type, std::string shape, size_t degree, size_t vectordim = 0);
    std::string type() const;
    std::string shape() const;
    size_t degree() const;
    size_t vectordim() const;
    std::string repr() const;

    friend std::ostream& operator<< (std::ostream& stream, const Finite_element_spec& spec);

private:

    std::string _type;
    std::string _shape;
    size_t _degree;
    size_t _vectordim;

};

#endif
