// Copyright (C) 2005 Johan Hoffman.
// Licensed under the GNU GPL Version 2.
//
// Modified by Pawel Krupinski 2007

#ifndef __FUNCTIONAL_H
#define __FUNCTIONAL_H

#include "Form.h"

/// Functional represents a functional F(u)

class Functional : public Form
{
public:

    /// Constructor
    Functional ( size_t num_functions = 0 );

    /// Destructor
    virtual ~Functional();

    /// Compute element vector (interior contribution)
    virtual void eval ( double block[], const Affine_map_shell<Mesh_face>& map ) const;

    /// Compute element vector (boundary contribution)
    virtual void eval ( double block[], const Affine_map_shell<Mesh_face>& map, size_t segment ) const;

    /// Return finite element defining the test space
    const Finite_element& test() const;

protected:
    // Finite element defining the test space
    Finite_element* _test;
};


#endif
