// Copyright (C) 2004-2006 Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Modified by Pawel Krupinski 2007

#include "fem/Linear_form.h"
#include "utils/error_macros.h"

//-----------------------------------------------------------------------------
Linear_form::Linear_form(size_t num_functions) : Form(num_functions), _test(0)
{
}
//-----------------------------------------------------------------------------
Linear_form::~Linear_form()
{
}
//-----------------------------------------------------------------------------
Finite_element& Linear_form::test()
{
    cell_assert(_test); // Should be created by child class
    return *_test;
}
//-----------------------------------------------------------------------------
void Linear_form::update(Affine_map_shell<Mesh_face> const& map) const
{
    // Update coefficients
    update_coefficients(map);
    // Initialize block
    const uint m = _test->spacedim();
    if ( !block )
        block = new double[m];
    for (uint i = 0; i < m; i++)
        block[i] = 0.0;
    // Initialize nodes
    if ( !test_nodes )
        test_nodes = new size_t[_test->spacedim()];
}
//-----------------------------------------------------------------------------
void Linear_form::update(double val, double *par)
{
}
//-----------------------------------------------------------------------------
