// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _HEX1P_RULE_H
#define _HEX1P_RULE_H

#include "utils/types.h"
//#include "fem/Affine_map.h"
#include "fem/quadrature_rule.h"

class Hex1P_rule: public Quadrature_rule
{
public:
	/// Return number of integration nodes
	size_t spacedim() const { return 1; }

	/// Return number of the underlying shape dim
	size_t shapedim() const { return 3; }

	/// Return integration points 
	void points( Point p[] ) const
	{
		p[0] = Point(0.0, 0.0, 0.0);
	}

	/// Return integration weigths 
	void weights( double w[] ) const
	{
		w[0] = 8.0;
	}

	/// Return specification for the rule
	inline std::string type() const
	{
		return std::string("[ 1 point rule on a hexadedron ]");
	}

};


#endif
