#ifndef _QUAD4P_RULE_H
#define _QUAD4P_RULE_H

#include "utils/types.h"
#include "fem/quadrature_rule_surface.h"

//quadrature rule for a quad
class Quad4P_rule: public Quadrature_rule_surface
{
	public:

	/// Return number of integration nodes
		size_t spacedim() const { return 4; }

	/// Return number of the underlying shape dim
		size_t shapedim() const { return 2; }

	/// Return integration points 
		void points( Point_2D p[] ) const
		{
			const double a = 1.0 / sqrt(3.0);
			
			p[0] = Point_2D(-a, -a);
			p[1] = Point_2D( a, -a);
			p[2] = Point_2D( a,  a);
			p[3] = Point_2D(-a,  a);
		}
	/// Return integration weigths 
		void weights( double w[] ) const
		{
			w[0] = 1.0;
			w[1] = 1.0;
			w[2] = 1.0;
			w[3] = 1.0;
		}

	/// Return specification for the rule
		inline std::string type() const
		{
			return std::string("[ 4 point rule on a quad ]");
		}

};


#endif