// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.

#ifndef _PRINCIPIAL_STRESS_H
#define _PRINCIPIAL_STRESS_H

#include <boost/shared_ptr.hpp>
#include "matrix/DenseVector.h"
#include "matrix/DenseMatrix.h"
#include "utils/types.h"
//-----------------------------------------------------------------------------
struct Principal_dir
{
    Principal_dir() : vec_form ( 3 ), eigenvectors ( 3,3 ) {}

    //vector of eigenvalues
    DenseVector vec_form;

    //matrix of eigenvectors
    DenseMatrix eigenvectors;

    DenseVector get_dense_vector ( int i ) const
    {
        boost::shared_ptr<ublas_vector> v ( new ublas_vector ( ublas::matrix_column<DenseMatrix::internal_type> ( const_cast<DenseMatrix::internal_type&> ( eigenvectors.mat() ), i ) ) );
        return DenseVector ( v );
    }

    Vector get_vector ( int i ) const
    {
        return Vector ( eigenvectors ( 0, i ),eigenvectors ( 1, i ), eigenvectors ( 2, i ) );
    }
};
//-----------------------------------------------------------------------------
#endif
