// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _QUADRATURE_RULE_SHELL_H_
#define _QUADRATURE_RULE_SHELL_H_

#include "utils/types.h"
//-----------------------------------------------------------------------------
class Quadrature_rule_shell
{
public:
    /// Constructor
    Quadrature_rule_shell();
    /// Destructor
    virtual ~Quadrature_rule_shell();
    /// Return number of integration nodes
    virtual size_t spacedim() const = 0;
    /// Return dimension of the underlying shape
    virtual size_t shapedim() const = 0;
    /// Return integration weigths
    virtual void weights ( double w[] ) const = 0;
    /// Return integration points
    virtual void points ( Point p[] ) const = 0;
    /// Return z positions of integration points
//    virtual void laminas( double z[] ) const = 0;
    /// Return an array of dofs for all integration points
    virtual void dofs ( double d[] ) const = 0;
    /// Return specification for element
    virtual std::string type() const = 0;
    /// Factory function for creating new rule
    static Quadrature_rule_shell* make_QRule ( std::string type );
    /// Display rule data
    void disp() const;
};
//-----------------------------------------------------------------------------
#endif
