// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _SHAPE_FUNCTION_H_
#define _SHAPE_FUNCTION_H_

// #include "utils/types.h"
//-----------------------------------------------------------------------------
//shape functions in local coordinate system description
class Shape_function
{
public:

    enum Coordinate_type {X,Y,Z};
    Shape_function();
    virtual ~Shape_function();
    ///Local shape function. Input: element node index, array of dofs
    virtual double function(int i, double *x) const = 0;
    ///Local derivative of shape function. Input: element node index, array of dofs, differentiation coordinate
    virtual double derivative(int i, double *x, Coordinate_type c_t) const = 0;
};
//-----------------------------------------------------------------------------
#endif
