// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef CELL_OSTREAM_BASE_H
#define CELL_OSTREAM_BASE_H

#include <fstream>

//-----------------------------------------------------------------------------
template<class Ostr>
class OfstreamBase :public Ostr
{
public:

	OfstreamBase(): m_ofs( new std::ofstream() ), m_ofs_local(true){Ostr::m_os = m_ofs;}
	OfstreamBase( std::ofstream &ofs): m_ofs( &ofs ), m_ofs_local(false){ OfstreamBase ::open( ofs ); Ostr::m_os = m_ofs; }
	OfstreamBase( std::string f_name ): m_ofs( new std::ofstream() ), m_ofs_local(true){ OfstreamBase ::open( f_name ); Ostr::m_os = m_ofs; }

	~OfstreamBase()
	{ 
		OfstreamBase ::close();
		if (m_ofs && m_ofs_local) delete m_ofs; 
	}

	void open( std::ofstream &ofs )
	{
		Ostr::open( ofs );
	}

	void open( std::string f_name )
	{
		m_ofs->open( f_name.c_str() ); 
		Ostr::open( *m_ofs );
	}

	void close()
	{ 
		Ostr::close();
		m_ofs->close(); 
	}

private:
	std::ofstream *m_ofs;
	bool m_ofs_local;
};
//-----------------------------------------------------------------------------
#endif
