// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _GENERIC_MATERIAL_H
#define _GENERIC_MATERIAL_H

#include "matrix/DenseMatrix.h"
#include "matrix/Matrix3.h"
#include "matrix/DenseVector.h"
#include <vector>
template<class ME> class Affine_map_shell;
class Mesh_face;
//-----------------------------------------------------------------------------
class Generic_material
{
public:

    ///constructors
    Generic_material() {}
    //update elastic tensor tangent and initail stress at given integration point
    virtual void elasticity( DenseMatrix &etens, Affine_map_shell<Mesh_face> const& map, int i ) const = 0;
    virtual void stress( Matrix3s &s, Affine_map_shell<Mesh_face> const& map, int i ) const = 0;
    virtual std::string info() const = 0;
};
//-----------------------------------------------------------------------------
#endif
