// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _CELL_BOUNDARY_BUILDER_H_
#define _CELL_BOUNDARY_BUILDER_H_

#include "mesh/mesh.h"
#include "cell/geom_data.h"
#include "cell/cell_handle.h"
#include "utils/geometry_utils.h"

class Boundary_builder
{
public:
    static Mesh_handle build_from_geom_data( Geom_data & gd, double tf, cell::Tissue_handle ts = cell::INVALID_TISSUE );

    static Mesh_handle build_from_mesh_file( std::ifstream & IN, cell::Tissue_handle ts = cell::INVALID_TISSUE );

    static Mesh_handle build_mesh( std::ifstream & IN );

    static void check_data( Mesh_handle m, Geom_data const& gd );

    static void process_geom_data( Mesh_handle m, Geom_data const& gd, cell::Tissue_handle ts );

    static void make_volume_walls( Mesh_handle m, double factor, Move_towards::Type tp, cell::Tissue_handle ts );

    //makes single wall cells from boundary mesh
    static Mesh_handle build_solid_cells( Mesh_handle m, cell::Tissue_handle ts = cell::INVALID_TISSUE );
};
//-----------------------------------------------------------------------------
#endif
