// Copyright (C) 2008 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _ITERATOR_PROJECTOR_FUNCTORS_H_
#define _ITERATOR_PROJECTOR_FUNCTORS_H_

#include "mesh/mesh_handle.h"
#include "utils/utility.h"
#include <iostream>
//these work for projecting normal iterators (returning pointers to entities) and return handles
//-----------------------------------------------------------------------------
template < class Mesh_entity >
struct Project_node
{
  typedef Mesh_entity argument_type;
  typedef Node_handle result_type;
  
  Node_handle operator() ( Mesh_entity& x )
  {
    return x->node();
  }
  const Node_handle operator() ( const Mesh_entity& x ) const
  {
    return x->node();
  }
};
//-----------------------------------------------------------------------------
template < class Mesh_entity >
struct Project_face
{
  typedef Mesh_entity argument_type;
  typedef Face_handle result_type;
  
  Face_handle operator() ( Mesh_entity& x )
  {
    return x->face();
  }
  const Face_handle operator() ( const Mesh_entity& x ) const
  {
    return x->face();
  }
};
//-----------------------------------------------------------------------------
template < class Mesh_entity >
struct Project_point
{
  typedef Mesh_entity argument_type;
  typedef Point           result_type;
  
  Point&  operator() ( Mesh_entity& x )
  {
    return x->point();
  }
  Point const& operator() ( const Mesh_entity& x ) const
  {
    return x->point();
  }
};
//these work for handle iterators (returning references to entities) and return handles
//-----------------------------------------------------------------------------
template < class Mesh_entity >
struct Project_node_handle
{
  typedef Mesh_entity argument_type;
  typedef Node_handle result_type;
  
  Node_handle& operator() ( Mesh_entity& x )
  {
    //       std::cout << "Project_node_handle::operator()\n";
    
    //       wait_kb_hit();
    return x.node();
  }
  const Node_handle& operator() ( const Mesh_entity& x ) const
  {
    //       std::cout << "Project_node_handle::operator() const\n";
    //       wait_kb_hit();
    return x.node();
  }
};
//-----------------------------------------------------------------------------
#endif
