// Copyright (C) 2008 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _MESH_HANDLE_H_
#define _MESH_HANDLE_H_

#include <ostream>
#include "utils/handle.h"

class Mesh_node;
class Mesh_edge;
class Mesh_face;
class Mesh_edge_use;
class Mesh_face_use;
class Mesh;

typedef Handle<Mesh_node>	Node_handle;
typedef Handle<Mesh_edge>	Edge_handle;
typedef Handle<Mesh_face>	Face_handle;
typedef Handle<Mesh_edge_use>	Edge_use_handle;
typedef Handle<Mesh_face_use>	Face_use_handle;
typedef Handle<Mesh>	Mesh_handle;

const Node_handle INVALID_NODE;
const Edge_handle INVALID_EDGE;
const Edge_use_handle INVALID_EDGE_USE;
const Face_handle INVALID_FACE;
const Face_use_handle INVALID_FACE_USE;
const Mesh_handle INVALID_MESH;

#endif
