// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _GRID_BASE_H_
#define _GRID_BASE_H_

#include "utils/types.h"
#include <fstream>
//#include "parameter/ParameterList.h"
//-----------------------------------------------------------------------------
class Grid_base
{
	public:
		typedef std::vector< Point >::iterator				Point_iterator;
		typedef std::vector< Point >::const_iterator		Point_const_iterator;
	
		size_t size_of_centers() const { return m_centers.size(); }
		size_t size_of_outer() const { return m_outer.size(); }
	
		Point_iterator centers_begin() { return m_centers.begin(); }
		Point_iterator centers_end() { return m_centers.end(); }
		Point_const_iterator centers_begin() const { return m_centers.begin(); }
		Point_const_iterator centers_end() const { return m_centers.end(); }
	
		Point_iterator outer_begin() { return m_outer.begin(); }
		Point_iterator outer_end() { return m_outer.end(); }
		Point_const_iterator outer_begin() const { return m_outer.begin(); }
		Point_const_iterator outer_end() const { return m_outer.end(); }
		
		void read_from_file(std::ifstream &in);
	
	protected:
		std::vector< Point > m_centers;
		std::vector< Point > m_outer;
};
//-----------------------------------------------------------------------------
#endif

