// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _SURFACE_TRANSFORM_H_
#define _SURFACE_TRANSFORM_H_

#include "utils/types.h"
#include "mesh_generator/voronoi2D.h"

//Base class for transformations creating three dimensional layer of cells from flat plane
//-----------------------------------------------------------------------------
class Surface_transform
{
public:
	
	//performs point transformation
	virtual Point operator()( Point const& p ) const = 0;
	Point transform( Point const& p ) const { return operator()(p); }
	
	Point operator()( Voronoi2D::Point_2 const& p ) const { return operator()( Point(p.x(), p.y(), 0.0 ) ); }
	Point transform( Voronoi2D::Point_2 const& p ) const { return operator()(p); }
	//changes parameters of transformation so that it will produce second layer ( h is supposed to be thickness of that layer )
	virtual void shift( double h ) = 0;
private:
};
//-----------------------------------------------------------------------------
#endif
