// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#include "mesh_generator/voronoi2D.h"
#include "mesh_generator/grid_base.h"
//-----------------------------------------------------------------------------
Voronoi2D::Voronoi2D ( Grid_base const& cg )
{
    Grid_base::Point_const_iterator p_iter, p_end;
    m_inner_cells.reserve ( cg.size_of_centers() );
    for ( p_iter = cg.centers_begin(), p_end = cg.centers_end(); p_iter != p_end; ++p_iter )
    {
        Face_handle const&fh = this->insert ( Site_2 ( p_iter->x(), p_iter->y() ) );
        if ( fh != Face_handle() )
            m_inner_cells.push_back ( fh );
    }
    m_outer_cells.reserve ( cg.size_of_outer() );
    for ( p_iter = cg.outer_begin(), p_end = cg.outer_end(); p_iter != p_end; ++p_iter )
    {
        Face_handle const&fh = this->insert ( Site_2 ( p_iter->x(), p_iter->y() ) );
        if ( fh != Face_handle() )
            m_outer_cells.push_back ( fh );
    }
}
//-----------------------------------------------------------------------------
