// Copyright (C) 2005-2006 Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Modified by Garth N. Wells, 2006.
// Modified by Pawel Krupinski 2007

#include <limits>
#include <string>
#include "parameter/ParameterSystem.h"

// Initialize the global parameter database
ParameterSystem ParameterSystem::parameters;

//-----------------------------------------------------------------------------
ParameterSystem::ParameterSystem() : ParameterList()
{
  // Include default values for parameters
#include "parameter/DefaultParameters.h"
}
//-----------------------------------------------------------------------------
void add(std::string key, Parameter value)
{
  ParameterSystem::parameters.add(key, value);
}
//-----------------------------------------------------------------------------
void set(std::string key, Parameter value)
{
  ParameterSystem::parameters.set(key, value);
}
//-----------------------------------------------------------------------------
Parameter get(std::string key)
{
  return ParameterSystem::parameters.get(key);
}
//-----------------------------------------------------------------------------
