// Copyright (C) 2005-2006 Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Modified by Pawel Krupinski 2007

#ifndef __PARAMETER_SYSTEM_H
#define __PARAMETER_SYSTEM_H

#include "ParameterList.h"

  class ParameterSystem : public ParameterList
  {
  public:

    /// Singleton instance of global parameter database
    static ParameterSystem parameters;

    /// Friends
    friend void add(std::string key, Parameter value);
    friend void set(std::string key, Parameter value);
    friend Parameter get(std::string key);

	using ParameterList::add;

  private:

    // Constructor
    ParameterSystem();
    
  };
  
  /// Add parameter
  void add(std::string key, Parameter value);
  
  /// Set value of parameter
  void set(std::string key, Parameter value);
  
  /// Get value of parameter with given key
  Parameter get(std::string key);
  

#endif
