// Copyright (C) 2008 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _POSTPROCESSING_UTILITIES_H_
#define _POSTPROCESSING_UTILITIES_H_

#include "matrix/DenseVector.h"
#include "mesh/mesh_handle.h"
#include "cell/cell_handle.h"
#include <fstream>
class Principal_dir;
class State_interpolator;
// class Tissue_handle;
//-----------------------------------------------------------------------------
void calculate_principial_stress( Principal_dir & p_s, DenseVector const&s_v, bool sign = false );
//-----------------------------------------------------------------------------
//sets fibers in the material in the direction of strongest principal stress
void align_material_fibers(Mesh_handle &m, State_interpolator const& si);
//-----------------------------------------------------------------------------
//write material fiber direction averaged per compartment
void write_compartment_fiber_vector(std::ofstream &os, cell::Tissue_handle ts);
//-----------------------------------------------------------------------------
//write principal stress direction averaged per compartment
void write_compartment_stress_vector(std::ofstream &os, State_interpolator& si, cell::Tissue_handle ts);
//-----------------------------------------------------------------------------
#endif
