#ifndef _DETERMINANT_H
#define _DETERMINANT_H

#include "utils/determinant_formula.h"
#include "utils/types.h"

double inline determinant( Vector v1, Vector v2, Vector v3 )
{
    return det3x3_by_formula( v1[0],  v2[0],  v3[0],
                              v1[1],  v2[1],  v3[1],
                              v1[2],  v2[2],  v3[2] );
}

Vector inline cross_product(Point p1, Point p2, Point p3)
{
    return Vector( (p2[1]-p1[1])*(p3[2]-p2[2]) - (p2[2]-p1[2])*(p3[1]-p2[1]),
                   (p2[2]-p1[2])*(p3[0]-p2[0]) - (p2[0]-p1[0])*(p3[2]-p2[2]),
                   (p2[0]-p1[0])*(p3[1]-p2[1]) - (p2[1]-p1[1])*(p3[0]-p2[0]));
}

double inline determinant( Point p1, Point p2, Point p3, Vector v3 )
{
    return det3x3_by_formula( p2[0]-p1[0], p3[0]-p2[0], v3[0],
                              p2[1]-p1[1], p3[1]-p2[1], v3[1],
                              p2[2]-p1[2], p3[2]-p2[2], v3[2] );
}
#endif //_DETERMINANT_H
