// Modified by Pawel Krupinski 2007
#ifndef _CELL_ERROR_MACROS_H_
#define _CELL_ERROR_MACROS_H_

#include "log_manager.h"

// Info (does not need to be a macro)
void cell_info(const char *msg, ...);
void cell_info_aptr(const char *msg, va_list aptr);

#define cell_debug(msg)                  do { Log_manager::log.debug(__FILE__, __LINE__, __FUNCTION__, msg); } while( false )
#define cell_debug1(msg, a0)             do { Log_manager::log.debug(__FILE__, __LINE__, __FUNCTION__, msg, a0); } while( false )
#define cell_debug2(msg, a0, a1)         do { Log_manager::log.debug(__FILE__, __LINE__, __FUNCTION__, msg, a0, a1); } while( false )
#define cell_debug3(msg, a0, a1, a2)     do { Log_manager::log.debug(__FILE__, __LINE__, __FUNCTION__, msg, a0, a1, a2); } while( false )
#define cell_debug4(msg, a0, a1, a2, a3) do { Log_manager::log.debug(__FILE__, __LINE__, __FUNCTION__, msg, a0, a1, a2, a3); } while( false )

// Warning macros (with varying number of arguments)

#define cell_warning(msg)                  do { Log_manager::log.warning(__FILE__, __LINE__, __FUNCTION__, msg); } while( false )
#define cell_warning1(msg, a0)             do { Log_manager::log.warning(__FILE__, __LINE__, __FUNCTION__, msg, a0); } while( false )
#define cell_warning2(msg, a0, a1)         do { Log_manager::log.warning(__FILE__, __LINE__, __FUNCTION__, msg, a0, a1); } while( false )
#define cell_warning3(msg, a0, a1, a2)     do { Log_manager::log.warning(__FILE__, __LINE__, __FUNCTION__, msg, a0, a1, a2); } while( false )
#define cell_warning4(msg, a0, a1, a2, a3) do { Log_manager::log.warning(__FILE__, __LINE__, __FUNCTION__, msg, a0, a1, a2, a3); } while( false )

#define cell_error(msg)                  do { Log_manager::log.error(__FILE__, __LINE__, __FUNCTION__, msg); } while( false )
#define cell_error1(msg, a0)             do { Log_manager::log.error(__FILE__, __LINE__, __FUNCTION__, msg, a0); } while( false )
#define cell_error2(msg, a0, a1)         do { Log_manager::log.error(__FILE__, __LINE__, __FUNCTION__, msg, a0, a1); } while( false )
#define cell_error3(msg, a0, a1, a2)     do { Log_manager::log.error(__FILE__, __LINE__, __FUNCTION__, msg, a0, a1, a2); } while( false )
#define cell_error4(msg, a0, a1, a2, a3) do { Log_manager::log.error(__FILE__, __LINE__, __FUNCTION__, msg, a0, a1, a2, a3); } while( false )

// Assertion, turned off if DEBUG is not defined

#ifdef DEBUG
#define cell_assert(check) do { if ( !(check) ) Log_manager::log.cassert(__FILE__, __LINE__, __FUNCTION__, "(" #check ")"); } while ( false )
#else
#define cell_assert(check)
#endif

#endif
