// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _FLAGABLE_H_
#define _FLAGABLE_H_

//A class for flag functionality. 
template<class F, F def= F()>
class Flag
{
  
public:
  typedef F Flag_type;
  
  Flag( F f ) : m_flag(f) {}
  Flag() : m_flag(def) {}
  
  F flag() const { return m_flag; }
  F& flag() { return m_flag; }
  void set_flag( F f ) { m_flag = f; }
  void reset_flag() { m_flag = def; }
  bool is_set() const {return m_flag != def; }
  F default_flag() const {return def;}
private:
  F m_flag;
};

typedef Flag<int, -1> Flagable;
#endif
