// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef CELL_FOURTUPLE_H
#define CELL_FOURTUPLE_H
#include "utils/error_macros.h"
template < class T >
struct Fourtuple
{
    typedef T value_type;

    T  e0, e1, e2, e3;

    Fourtuple() {}

    Fourtuple ( const T & a0, const T & a1, const T & a2, const T & a3 ) : e0 ( a0 ), e1 ( a1 ), e2 ( a2 ), e3 ( a3 ) {}

    T& operator[] ( int i )
    {
        cell_assert ( i < 4 );
        switch ( i )
        {
        case 0 :
            return e0;
        case 1 :
            return e1;
        case 2 :
            return e2;
            //break;
        case 3 :
            return e3;
        }
        //return value to avoid compiler errors/warnings. Never reached
        return e0;
    }
    const T& operator[] ( int i ) const
    {
        cell_assert ( i < 4 );
        switch ( i )
        {
        case 0 :
            return e0;
        case 1 :
            return e1;
        case 2 :
            return e2;
            //break;
        case 3 :
            return e3;
        }
        //return value to avoid compiler errors/warnings. Never reached
        return e0;
    }
};


#endif // CELL_FOURTUPLE_H
