// Modified by Pawel Krupinski 2007
#ifndef _CELL_LOGGER_H
#define _CELL_LOGGER_H

#include "logger_base.h"
#include <stdarg.h>

class Logger
{
public:

    Logger();
    ~Logger();

    void info    (const char* msg);
    void info    (const char* format, va_list aptr);

    void debug   (const char* file, unsigned long line, const char* function, const char* format, ...);
    void warning (const char* file, unsigned long line, const char* function, const char* format, ...);
    void error   (const char* file, unsigned long line, const char* function, const char* format, ...);
    void cassert (const char* file, unsigned long line, const char* function, const char* format, ...);

    void begin();
    void end();

    void active(bool state);

    void init(const char* destination);

private:

    void init();

    Logger_base* log;
    char* buffer;
    char* location;
    bool state;
};

#endif
