// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _SEARCH_SINGLE_H_
#define _SEARCH_SINGLE_H_
#include<algorithm>

//version of search_single based on std::search_n
template<class ForwardIterator1, class Type> inline
bool search_single ( ForwardIterator1 _First1, ForwardIterator1 _Last1, const Type& _Val )
{
    return ( std::search_n ( _First1 , _Last1, 1, _Val ) != _Last1 );
}
//
//-----------------------------------------------------------------------------
template<class ForwardIterator1, class Type, class BinaryPredicate> inline
bool search_single ( ForwardIterator1 _First1, ForwardIterator1 _Last1, const Type& _Val, BinaryPredicate _Comp )
{
    return ( std::search_n ( _First1 , _Last1, 1, _Val, _Comp ) != _Last1 );
}

#endif
