// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#ifndef _STRING_UTILS_H_
#define _STRING_UTILS_H_

#include <string>
#include <sstream>
//-----------------------------------------------------------------------------
template <class T>
std::string to_string(T i)
{
    std::ostringstream s1;
    s1 <<  i ;
    std::string s2 = s1.str();
    return s2;
}
//-----------------------------------------------------------------------------
template <class T>
bool from_string(T& t,
                 const std::string& s,
                 std::ios_base& (*f)(std::ios_base&) = std::dec)
{
    std::istringstream iss(s);
    return !(iss >> f >> t).fail();
}
//-----------------------------------------------------------------------------
#endif

