// Copyright (C) 2007 Pawel Krupinski.
// Licensed under the GNU GPL Version 2.
#include <iostream>
#include "terminal_logger.h"
#include <stdlib.h>

//-----------------------------------------------------------------------------
Terminal_logger::Terminal_logger() : Logger_base()
{

}
//-----------------------------------------------------------------------------
Terminal_logger::~Terminal_logger()
{

}

//-----------------------------------------------------------------------------
void Terminal_logger::info(const char* msg)
{
  indent();
  std::cout << msg << std::endl;
}

//-----------------------------------------------------------------------------
void Terminal_logger::debug(const char* msg, const char* location)
{
	indent();
	std::cout << "[Debug at " << location << "]: " << msg << std::endl;
}

//-----------------------------------------------------------------------------
void Terminal_logger::warning(const char* msg, const char* location)
{
	indent();
	std::cout << "*** Warning: " << msg << " [" << location << "]" << std::endl;
}

//-----------------------------------------------------------------------------
void Terminal_logger::error(const char* msg, const char* location)
{
	indent();
	std::cout << "*** Error: " << msg << " [" << location << "]" << std::endl;
	exit(1);
}

//-----------------------------------------------------------------------------
void Terminal_logger::cassert(const char* msg, const char* location)
{
	indent();
	std::cout << "*** Assertion " << msg << " failed [" << location
		<< "]" <<  std::endl;
	exit(1);
}
//-----------------------------------------------------------------------------
void Terminal_logger::indent()
{
	// Indent output to indicate the level
	for (int i = 0; i < level; i++)
		std::cout << "  ";
}
